local LDB
local parent = CreateFrame('Frame')

 -- Get a reference to the lib
local LibQTip = LibStub('LibQTip-1.0')
local tooltip = nil
local tooltip2 = nil

local function UpdateDisplay()
	if lastmountIndex ~= nil then
		local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(lastmountIndex)
		if spellID ~= 55164 then -- swift spectral gryphon
		LDB.text = lastmountText
		LDB.icon = lastmountIcon
		end
		 -- check to see if a new companion was learned and moved the index of the last
		if creatureName ~= lastmountText then
			for i = 1, C_MountJournal.GetNumMounts() do
			local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(i)
			if creatureName == lastmountText then
				lastmountIndex = i
			end
			end
		end
	end
	
	if favmount1index ~= nil  then
		local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(favmount1index)
		if creatureName ~= favmount1name then
			for i = 1, C_MountJournal.GetNumMounts() do
			local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(i)
			if creatureName == favmount1name then
				favmount1index = i
			end
			end
		end
	end
	if favmount2index ~= nil  then
		local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(favmount2index)
		if creatureName ~= favmount2name then
			for i = 1, C_MountJournal.GetNumMounts() do
			local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(i)
			if creatureName == favmount2name then
				favmount2index = i
			end
			end
		end
	end
	if favmount3index ~= nil  then
		local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(favmount3index)
		if creatureName ~= favmount3name then
			for i = 1, C_MountJournal.GetNumMounts() do
			local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(i)
			if creatureName == favmount3name then
				favmount3index = i
			end
			end
		end
	end
	
	for i = 1, C_MountJournal.GetNumMounts() do
	local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(i)
		if active and spellID ~= 55164 then --swift spectral gryphon check
			LDB.text = creatureName
			LDB.icon = icon
			lastmountIcon = icon
			lastmountIndex = i
			lastmountSpell = spellID
			lastmountText = creatureName
			return
		end
		if lastmountSpell ~= nil and lastmountText ~= nil then
		local isUsableSpell, notEnoughMana = IsUsableSpell(lastmountSpell)
			if isUsableSpell then
				LDB.text = lastmountText
			else
				LDB.text = string.format('|cff848484%s|r', lastmountText)
			end
		end
	end
end

local function ModifiedClick(button, index)	
local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(index)
	if IsShiftKeyDown() then
		C_MountJournal.Pickup(index)
	elseif IsAltKeyDown()and not IsControlKeyDown()  then
		favmount1index = index
		favmount1name = creatureName
		favmount1icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerMounts:|r %s added as favorite 1.", creatureName))
	elseif IsControlKeyDown() and not IsAltKeyDown() then
		favmount2index = index
		favmount2name = creatureName
		favmount2icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerMounts:|r %s added as favorite 2.", creatureName))
	elseif IsControlKeyDown() and IsAltKeyDown() then
		favmount3index = index
		favmount3name = creatureName
		favmount3icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerMounts:|r %s added as favorite 3.", creatureName))
	else
		C_MountJournal.Summon(index)
	end
	LibQTip:Release(tooltip)
	tooltip = nil
end

local function GetNumOwnedMounts()
local numOwnedMounts = 0
	for i = 1, C_MountJournal.GetNumMounts() do
		local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(i)
		if isCollected and not hideOnChar then
			numOwnedMounts = numOwnedMounts + 1
		end
		
	end
	return numOwnedMounts
end

local function OnEnter(self)	
   -- Acquire a tooltip with 1 columns, aligned to left
tooltip2 = LibQTip:Acquire("BrokerMountsTooltip2", 1, "LEFT") 
self.tooltip2 = tooltip2
  
   -- Use smart anchoring code to anchor the tooltip to our frame
tooltip2:SmartAnchorTo(self)
tooltip2:Clear()   

	tooltip2:AddHeader('|cff00ffffBrokerMounts|r')
	tooltip2:AddLine("|cffffff00<Right Click>|r to open mount list")
	tooltip2:AddLine("|cffffff00<Left Click>|r to mount/dismount")
	tooltip2:AddLine("|cffffff00<Alt-Right Click>|r to summon a random favorite mount")
	tooltip2:AddLine("|cffffff00<Shift-Left Click>|r plugin to open mount journal")
	tooltip2:AddLine("|cffffff00<Shift-Left Click>|r on mount to pick it up")
	if togglefavorite then
	tooltip2:AddLine("|cffffff00<Shift-Right Click>|r to toggle favorite mount list (|cff00ff00On|r)")
	else
	tooltip2:AddLine("|cffffff00<Shift-Right Click>|r to toggle favorite mount list (|cffff0000Off|r)")
	end
	if favmount1index then
	tooltip2:AddLine(format("|cffffff00<ALT-Click>|r |T%s:16|t%s", favmount1icon, favmount1name))
	else
	tooltip2:AddLine("|cffffff00<ALT-Click>|r mount to set as favorite 1")
	end
	if favmount2index then
	tooltip2:AddLine(format("|cffffff00<CTRL-Click>|r |T%s:16|t%s", favmount2icon, favmount2name))
	else
	tooltip2:AddLine("|cffffff00<CTRL-Click>|r mount to set as favorite 2")
	end
	if favmount3index then
	tooltip2:AddLine(format("|cffffff00<CTRL-ALT-Click>|r |T%s:16|t%s", favmount3icon, favmount3name))
	else
	tooltip2:AddLine("|cffffff00<CTRL-ALT-Click>|r mount to set as favorite 3")
	end
	if GetNumOwnedMounts() == 0 then
	tooltip2:AddLine("|cffff0000You have no mounts|r")
	else
	tooltip2:AddLine(string.format("|cff00ff00You have %s mounts|r", GetNumOwnedMounts() ))
	end
	 -- Show it
	if tooltip and tooltip:IsShown() then
		LibQTip:Release(self.tooltip2)
		self.tooltip2 = nil
	else
		tooltip2:Show()
	end
end



local function CreateMountTooltip(self)  
   -- Acquire a tooltip with 1 columns, aligned to left
tooltip = LibQTip:Acquire("BrokerMountsTooltip", 1, "LEFT") 
self.tooltip = tooltip 
tooltip:EnableMouse(true)
tooltip:SetAutoHideDelay(1, self)
  
   -- Use smart anchoring code to anchor the tooltip to our frame
tooltip:SmartAnchorTo(self)
tooltip:Clear()
local numlines = 0
	for i = 1, C_MountJournal.GetNumMounts() do
		local creatureName, spellID, icon, active, isUsable, sourceType, isFavorite, isFactionSpecific, faction, hideOnChar, isCollected = C_MountJournal.GetMountInfo(i)
		local creatureDisplayID, descriptionText, sourceText, isSelfMount, mountType = C_MountJournal.GetMountInfoExtra(i)
		local isUsableSpell, notEnoughMana = IsUsableSpell(spellID)
		local MountFlag
		if mountType ==  247 or mountType ==  248 then --Flying
			MountFlag = "|cff4d9cdf(F)|r"
		elseif mountType ==  230 then --Ground
			MountFlag = "|cffaa6641(G)|r"
		elseif mountType ==  231 or  mountType ==  232 then --Water
			MountFlag = "|cff00ffff(A)|r"
		else
			MountFlag = "|cffffff00(S)|r"
		end
		local fav = ""
		if isFavorite then
			fav = "*"
		end
		 -- Add an new line, using all columns
		if isCollected and not hideOnChar and not togglefavorite then
			if (UnitFactionGroup("player") == "Horde" and faction ~= 1) or (UnitFactionGroup("player") == "Alliance" and faction ~= 2) then
			if isUsable then
			if isUsableSpell then
				if active then
				numlines = numlines + 1
					tooltip:AddLine(format("|T%s:16|t %s|cff00ff00%s %s|r", icon, fav, creatureName, MountFlag))
					tooltip:SetCellScript(numlines, 1, "OnMouseUp", ModifiedClick, i)
				--elseif not isUsable then
				--numlines = numlines + 1
					--tooltip:AddLine(format("|T%s:16|t %s|cffff0000%s %s|r", icon, fav, creatureName, MountFlag))
					--tooltip:SetCellScript(numlines, 1, "OnMouseUp", ModifiedClick, i)	
				else 
				numlines = numlines + 1
					tooltip:AddLine(format("|T%s:16|t %s%s %s", icon, fav, creatureName, MountFlag))
					tooltip:SetCellScript(numlines, 1, "OnMouseUp", ModifiedClick, i)
				end
			else
			numlines = numlines + 1
				tooltip:AddLine(format("|T%s:16|t %s|cff848484%s %s|r", icon, fav, creatureName, MountFlag))
				tooltip:SetCellScript(numlines, 1, "OnMouseUp", ModifiedClick, i)
			end
			end
			end
		elseif isCollected and not hideOnChar and togglefavorite and isFavorite then
			if (UnitFactionGroup("player") == "Horde" and faction ~= 1) or (UnitFactionGroup("player") == "Alliance" and faction ~= 2) then
			if isUsable then
			if isUsableSpell then
				if active then
				numlines = numlines + 1
					tooltip:AddLine(format("|T%s:16|t %s|cff00ff00%s %s|r", icon, fav, creatureName, MountFlag))
					tooltip:SetCellScript(numlines, 1, "OnMouseUp", ModifiedClick, i)
				--elseif not isUsable then
				--numlines = numlines + 1
					--tooltip:AddLine(format("|T%s:16|t %s|cffff0000%s %s|r", icon, fav, creatureName, MountFlag))
					--tooltip:SetCellScript(numlines, 1, "OnMouseUp", ModifiedClick, i)	
				else 
				numlines = numlines + 1
					tooltip:AddLine(format("|T%s:16|t %s%s %s", icon, fav, creatureName, MountFlag))
					tooltip:SetCellScript(numlines, 1, "OnMouseUp", ModifiedClick, i)
				end
			else
			numlines = numlines + 1
				tooltip:AddLine(format("|T%s:16|t %s|cff848484%s %s|r", icon, fav, creatureName, MountFlag))
				tooltip:SetCellScript(numlines, 1, "OnMouseUp", ModifiedClick, i)
			end
			end
			end
		end
	end
   tooltip:UpdateScrolling(500)
   -- Show it
	if tooltip:IsShown() then
		LibQTip:Release(self.tooltip)
		self.tooltip = nil	
	else
		tooltip:Show()
		LibQTip:Release(self.tooltip2)
		tooltip2 = nil
	end
end
 
local function OnLeave(self)  
   -- Release the tooltip
   LibQTip:Release(self.tooltip2)
   self.tooltip2 = nil 
   
end
 
local function OnClick(self, button)
	if (button == 'RightButton'and not IsShiftKeyDown() and not IsAltKeyDown() and not IsControlKeyDown()) then
		CreateMountTooltip(self)
	end
	if (button == 'RightButton'and IsShiftKeyDown() and not IsAltKeyDown() and not IsControlKeyDown()) then
		if togglefavorite == true then
			togglefavorite = false
		else
			togglefavorite = true
		end
	end
	if (button == 'LeftButton' and not IsShiftKeyDown() and not IsAltKeyDown() and not IsControlKeyDown()) then
		if IsMounted() then
			C_MountJournal.Dismiss()
		elseif lastmountIndex ~= nil then
			C_MountJournal.Summon(lastmountIndex)
		end
	elseif (IsShiftKeyDown() and button == 'LeftButton') then	
		TogglePetJournal(1)	
	elseif (button == 'LeftButton' and IsAltKeyDown() and not IsControlKeyDown()) then
		if favmount1index ~= nil then
			C_MountJournal.Summon(favmount1index)
		end
	elseif (button == 'LeftButton' and IsControlKeyDown() and not IsAltKeyDown()) then
		if favmount2index ~= nil then
			C_MountJournal.Summon(favmount2index)
		end
	elseif (button == 'LeftButton' and IsControlKeyDown() and IsAltKeyDown()) then
		if favmount3index ~= nil then
			C_MountJournal.Summon(favmount3index)
		end
	elseif (button == 'RightButton' and IsAltKeyDown() and not IsControlKeyDown()) then
			C_MountJournal.Summon(0)
	end
end

function parent:PLAYER_LOGIN()
	LDB = LibStub('LibDataBroker-1.1'):NewDataObject('BrokerMounts', {
		icon = "Interface\\Icons\\INV_Misc_QuestionMark.blp",
		text = "BrokerMounts",
		type = 'data source',
		--OnTooltipShow = OnTooltipShow,
		OnEnter = OnEnter,
		OnLeave = OnLeave,
		OnClick = OnClick,
	})
	self:RegisterEvent('SPELL_UPDATE_USABLE')
	self:RegisterEvent('COMPANION_UPDATE')
	self.COMPANION_UPDATE = UpdateDisplay
	self.SPELL_UPDATE_USABLE = UpdateDisplay
	
	UpdateDisplay()
end

 -- Somewhere in the anchor initialization
parent:SetScript('OnEnter', OnEnter)
parent:SetScript('OnLeave', OnLeave)
parent:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
parent:RegisterEvent('PLAYER_LOGIN')